/**
 * @file tuya_device_cfg.h
 * @brief
 * @version 0.1
 * @date 2023-06-26
 *
 * @copyright Copyright (c) 2023 Tuya Inc. All Rights Reserved.
 *
 * Permission is hereby granted, to any person obtaining a copy of this software and
 * associated documentation files (the "Software"), Under the premise of complying
 * with the license of the third-party open source software contained in the software,
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software.
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 */

#ifndef __TUYA_DEVICE_CFG_H__
#define __TUYA_DEVICE_CFG_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifndef TY_SPK_DEFAULT_VOL
#define TY_SPK_DEFAULT_VOL 70
#endif

/**
 * @brief Firmware info
 *
 */
#define GFW_FIRMWARE_KEY "key4pd7y9xyxfvdu"

/**
 * @brief
 */
#define ENABLE_GFW_CMD_STANDALONE_SECTION   0

/**
 * @brief
 */
#define ENABLE_GFW_SDK_TEST     1

/**
 * @brief
 *
 */
#define ENABLE_GFW_WEATHER      0

/**
 * @brief
 */
#define ENABLE_GFW_IR 0

/**
 * @brief
 */
#define ENABLE_GFW_RF 0

/**
 * @brief
 *
 */
#define ENABLE_GFW_STREAM 0

/**
 * @brief
 *
 */
#define ENABLE_GFW_BLE 1

/**
 * @brief
 */
#define ENABLE_GFW_VOL_FILE 0

/**
 * @brief
 */
#define ENABLE_GFW_KEPLER_FILE 1

/**
 * @brief
 */
#define ENABLE_GFW_KEPLER_FILE_UPLOAD 1

/**
 * @brief
 */
#define ENABLE_GFW_KEPLER_FILE_DOWNLOAD 1

/**
 * @brief
 */
#define ENABLE_GFW_PROD_TEST 1

/**
 * @brief
 */
#define ENABLE_GFW_PCBA_TEST 0

/**
 * @brief 红外IO TX数组列表
 */
#define TY_IR_TX_IO_ARRAY                                      \
    {                                                          \
        TUYA_GPIO_NUM_12, TUYA_GPIO_NUM_13,  TUYA_GPIO_NUM_25, \
        TUYA_GPIO_NUM_26, TUYA_GPIO_NUM_52, TUYA_GPIO_NUM_53   \
    }

/**
 * @brief 红外IO RX数组列表学习以及测试确认
 */
#define TY_IR_RX_IO_ARRAY                                       \
    {                                                           \
        TUYA_GPIO_NUM_12, TUYA_GPIO_NUM_13,  TUYA_GPIO_NUM_15,  \
        TUYA_GPIO_NUM_26, TUYA_GPIO_NUM_28, TUYA_GPIO_NUM_52,   \
        TUYA_GPIO_NUM_53                                        \
    }

/**
 * @brief 红外RX和TX默认io
 */
#define TY_IR_TX_IO     TUYA_GPIO_NUM_12
#define TY_IR_RX_IO     TUYA_GPIO_NUM_13

/**
 * @brief 模组空闲可使用io列表
 */
#define TY_IDLE_IO_ARRAY                                        \
    {                                                           \
        TUYA_GPIO_NUM_12, TUYA_GPIO_NUM_13,  TUYA_GPIO_NUM_15,  \
        TUYA_GPIO_NUM_25, TUYA_GPIO_NUM_26, TUYA_GPIO_NUM_28,   \
        TUYA_GPIO_NUM_52, TUYA_GPIO_NUM_53                      \
    }

/**
 * @brief 模组支持的串口波特率列表
 */
#define TY_BAUD_LIST {9600, 115200}

/**
 * @brief 串口缓冲区长度
 */
#define TY_UART_BUF_SIZE (2048)

#ifdef __cplusplus
}
#endif

#endif // __TUYA_DEVICE_CFG_H__
