#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <libgen.h>
#include <signal.h>
#include <sys/prctl.h>
#include <time.h>

#include "utilities/uni_log.h"
#include "tuya_iot_config.h"
#include "tuya_ai_mp3_player.h"

OPERATE_RET tuya_ai_mp3_player_init(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

FILE * s_mp3_file = NULL;
INT_T tuya_ai_mp3_stream_write(CHAR_T *buf, UINT_T len)
{
    PR_ERR("%s", __func__);
    if (NULL == buf){
        // 如果 buff 为 NULL，表示数据输入结束，关闭文件
        if (s_mp3_file) {
            fclose(s_mp3_file);
            printf("File closed and saved.\n");
            s_mp3_file = NULL;
        }
        return 0;        
    }

    // 如果文件未打开，先创建文件
    if (!s_mp3_file) {
        // 获取当前时间，用于生成文件名
        time_t now = time(NULL);
        struct tm* tm_info = localtime(&now);

        char filename[128];
        snprintf(filename, sizeof(filename), "%04d%02d%02d_%02d%02d%02d.mp3",
                tm_info->tm_year + 1900, // 年份需要加 1900
                tm_info->tm_mon + 1,     // 月份需要加 1
                tm_info->tm_mday,       // 日
                tm_info->tm_hour,       // 小时
                tm_info->tm_min,        // 分钟
                tm_info->tm_sec);       // 秒

        // 打开文件
        s_mp3_file = fopen(filename, "wb");
        if (!s_mp3_file) {
            perror("Failed to open file");
            return -1;
        }
        printf("File opened: %s\n", filename);
    }

    // 将数据写入文件
    fwrite(buf, 1, len, s_mp3_file);
    printf("Wrote %zu bytes to file.\n", len);   
    return len;
}

INT_T tuya_ai_mp3_stream_read(CHAR_T *buf, UINT_T len)
{
    PR_ERR("%s", __func__);
    return 0;
}

INT_T tuya_ai_mp3_stream_get_size(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

INT_T tuya_ai_mp3_stream_avail_size(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

OPERATE_RET tuya_ai_mp3_stream_clear(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

OPERATE_RET tuya_ai_mp3_player_play_raw(CHAR_T *data, UINT_T len)
{
    PR_ERR("%s", __func__);
    return 0;
}

OPERATE_RET tuya_ai_mp3_player_play_alert(TUYA_AI_ALART_TYPE type, BOOL_T send_eof)
{
    PR_ERR("%s", __func__);
    return 0;    
}

OPERATE_RET tuya_ai_mp3_player_start(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

OPERATE_RET tuya_ai_mp3_player_stop(VOID)
{
    PR_ERR("%s", __func__);
    return 0;
}

BOOL_T tuya_ai_mp3_is_playing(VOID)
{
    PR_ERR("%s", __func__);
    return FALSE;
}

OPERATE_RET tuya_ai_player_set_volume(INT_T vol)
{
    PR_ERR("%s", __func__);
    return 0;
}

INT_T tuya_ai_player_get_volume(VOID)
{
    PR_ERR("%s", __func__);
    return 0; 
}
